;Examples for _AssembleIt()
;32 Bit only!
#include <AssembleIt.au3>
#include <array.au3>


;the following functions are called by _AssembleIt()

Func _Add_int()                         ;any functionname, used by _AssembleIt()
    _("use32")                          ;32 Bit
    _("mov eax,dword[esp+4]")           ;read 1.Parameter in Register
    _("add eax,dword[esp+8]")           ;add 2.Parameter
    _("ret")                            ;Returns result in EAX back to the calling function: NO STACK CLEANING NECESSARY!
    _("")                               ;copy "empty" functions to save the hard work pressing keys at keyboard :o)
    _("")
EndFunc                                 ;==>_Add_int

Func _Sub_float()
    _("use32")
    _("finit")                          ;init FloatingPoint-Processor and FP-Register
    _("fld dword[esp+4]")               ;1. Parameter into ST0-Floatingpointregister
    _("fsub dword[esp+8]")              ;Subtraction of two FP
    _("ret")                            ;If the Return-Type is one of the "float" , ST0 is returned
EndFunc                                 ;==>_Sub_float

Func _Sub_double()
    _("use32")
    _("finit")                          ;init FloatingPoint-Register
    _("fld qword[esp+4]")               ;1. Parameter 64Bit(up to 80Bit possible) into ST0-Floatingpointregister
    _("fsub qword[esp+12]")             ;Subtraction of two 64Bit-Numbers  !BEWARE! Double is 64Bit wide, so +12 (4 + 8 Byte double = 12)
    _("ret")                            ;returns ST0
EndFunc                                 ;==>_Sub_double

Func _Errortest()
    _("use32")
    _("mov eax,0xDEAD")                 ; Name ist Program^^
    _("jmp _THERE")                     ;jump to label _THERE triggers an error in the Assembler, because this label doesnt exist
    _("mov eax,0xBEEEEEEF")             ;
    _("")
    _("_HERE:")                         ;change it to _THERE to eliminate the error
    _("ret ")
EndFunc                                 ;==>_Errortest

Func _make_opcode()                    ;Example, how to generate a CallWindowProcW-Call
    _("use32")                          ;
    _("mov eax,dword[esp+4]")           ;1.Parameter into Register
    _("add eax,dword[esp+8]")           ;add 2.Parameter
    _("ret")                            ;returns result into EAX
EndFunc                                 ;==>_run_bytecode


;call:     _AssembleIt(Returntype,Funcionname,Type1,Para1, Type2, Para2....,Type20,Para20)
;Return:     Result in EAX, ST0 depending of ReturnType

;Example_1
$ret = _AssembleIt("int", "_Add_int", "int", 22, "int", 33)
MsgBox(262144, 'Result _Add_int()', $ret)

;Example_2
$float1 = 103.444
$float2 = 43.222
$ret = _AssembleIt("float", "_Sub_float", "float", $float1, "float", $float2)
MsgBox(262144, 'Result _Sub_float()', 'Assembler: ' & $ret & @CRLF & 'AutoIt: ' & $float1 - $float2)

;Example_3
$double1 = 103.444
$double2 = 43.222
$ret = _AssembleIt("double", "_Sub_double", "double", $double1, "double", $double2)
MsgBox(262144, 'Result _Sub_double()', 'Assembler: ' & $ret & @CRLF & 'AutoIt: ' & $double1 - $double2)

;Example_4
;errortest
$ret = _AssembleIt("ptr", "_Errortest")
If @error Then
    MsgBox(0, "_AssembleIt_EXAMPLE", "Error in Function _Errortest" & @CRLF & "Errorcode: " & $ret)
Else
    MsgBox(0, "Ergebnis _Errortest", $ret)
EndIf


;example_5
;using of the $_ASSEMBLEIT_FLAG = 0 causes an creation of 3 lines AutoItscript
$_ASSEMBLEIT_FLAG = 0                   ;ASM-Code will be assembled and after that, an AutoIt-script is created which runs a CallWindowProcW-call
$ret = _AssembleIt("int", "_make_opcode", "int", 22, "int", 33) ;Script ends here if $_ASSEMBLEIT_FLAG is set to 0!

;The following 3 lines should be the Code in the Clipboard (CTRL+V to insert). To run this 3 lines, no FASM.au3 is necessary!
;Global $tCodeBuffer = DllStructCreate("byte[9]") ;reserve Memory for opcodes
;DllStructSetData($tCodeBuffer, 1,"0x8B44240403442408C3") ;write opcodes into memory
;$ret=DllCall("user32.dll", "int", "CallWindowProcW", "ptr", DllStructGetPtr($tCodeBuffer),"int",Param1,"int",Param2,"int",0,"int",0)

;please change the Param1 and Param2 to the parameters you want to use or copy them from the _AssembleIt()-function!
;remember, that DllCall returns an array!


FasmExit($Fasm)
Exit













